/*
Autor:		Rafael Alberto Moreno Parra
URL:		http://www.geocities.com/krousky
Clase:		Inicializa.
Lenguaje:	C++

Propsito:
Inicializa las variables para la simulacin

Mtodos:

*/
class Inicializa {
public:

	struct stDatosSimul
	{
   		//Probabilidades, estos datos se leen de un archivo de inicializacin
		unsigned int iPosibIf; //Posibilidad de que la instruccin sea IF
		unsigned int iPosibSet; //Posibilidad de que la instruccin sea Asignacin
		unsigned int iPosibFun; //Posibilidad de que la instruccin sea Funcion
		
		unsigned int iPosW; //Posibilidad de que la variable activa sea W
		unsigned int iPosX; //Posibilidad de que la variable activa sea X
		unsigned int iPosY; //Posibilidad de que la variable activa sea Y
		unsigned int iPosZ; //Posibilidad de que la variable activa sea Z
		
		unsigned int iPosIg; //Posibilidad de comparativo =
		unsigned int iPosMay;//Posibilidad de comparativo >
		unsigned int iPosMen;//Posibilidad de comparativo <
		unsigned int iPosDif;//Posibilidad de comparativo !
		
		unsigned int iLongExpr; //Longitud de las expresiones
		
		unsigned int iPosibX; //Posibilidad de Variable 1 en la expresin
		unsigned int iPosibY; //Posibilidad de Variable 2 en la expresin
		unsigned int iPosibP; //Posibilidad de salir Parentesis
		unsigned int iPosibN; //Posibilidad de salir Nmero
		
		unsigned int iNumCiclos; //Maximo CPU
		unsigned int iNumInstMax; //Numero de instrucciones(genes) mximo generado

		unsigned int iAnchoTabl; //Ancho tabla
		unsigned int iLargoTabl; //Largo tabla
		unsigned int iTotalOrg; //Total Organismos a evaluar

		char sArchResult[50]; //Archivo donde se guarda el resultado
	};  

	struct stDatosSimul stDatVA; //Datos Vida Artificial
	void vPantallaIni(void);
    int vLeeArchivoIni(void);
	void vArchResult(void);
	void vGrabaOrganismos(unsigned int iAciertos, char *sMensaje);
	void Inicializa::vFinalSimulacion(void);
};
